def merge(a, b):
    #Function to merge two lists a and b into a new list
    newlist = []
    index1 = 0
    index2 = 0
    #Check each item in each list, and add the smallest item to a new list
    while((index1 < len(a)) and (index2 < len(b))):

        if(a[index1] > b[index2]):
            newlist.append(b[index2])
            index2 = index2 + 1

        elif(a[index1] < b[index2]): 
            newlist.append(a[index1])
            index1 = index1 + 1

        elif(a[index1] == b[index2]):
            newlist.append(a[index1])
            newlist.append(b[index2])
            index1 = index1 + 1
            index2 = index2 + 1

    #Add left over items from the remaining list
    if(index1 < len(a)):
        for f in range(index1, len(a)):
            newlist.append(a[f])
    elif(index2 < len(b)):  
        for k in range(index2, len(b)):
            newlist.append(b[k])

    return newlist

#Main algorithm starts here
items = [38,27,43,3,9,82]
listofitems = []
#Every item is put into it's own list within a container list
for n in range(len(items)):
    item = [items[n]]
    listofitems.append(item)

#Repeat whilst there is more than one list
while len(listofitems) != 1:  
    index = 0
    #Merge pairs of lists
    while(index < len(listofitems)-1): 
        newlist = merge(listofitems[index], listofitems[index+1])
        listofitems[index] = newlist
        #Once merged, delete one of the now redundant lists
        del listofitems[index+1]

#Output
print(listofitems[0])

